using System;
using System.IO;
using System.Linq;

class Program {
    static void Main() {
        // Read input, sort characters (e.g. 98765), convert to Enumerable<int>
        // Add two zeroes to simplify the Zip operation later
        var n = File.ReadLines("magsis.txt").ToList()[1].OrderByDescending(x => x).Select(x=>x-'0').Concat(new[]{0, 0}).ToList();

        // Extract even and odd characters (e.g. 9750, 860)
        var left = n.Where((c,i) => i % 2 == 0);
        var right = n.Where((c,i) => i % 2 == 1);

        // Sum two reversed bignums (9750 + 860 => (579+68 = 647) => 7460)
        var carry = 0;
        var sum = left.Zip(right, (a,b) => {
            var res = (a+b+carry)%10;
            carry = (a+b+carry)/10;
            return res;
        }).ToList();

        // Drop extra zeroes from the beginning (7460 => 746), reverse (764 => 647) and output
        while (sum.Count() > 1 && sum.Last() == 0) sum.RemoveAt(sum.Count() - 1);
        File.WriteAllLines("magval.txt", new[]{ string.Concat(Enumerable.Reverse(sum)) });
    }
}