#include<iostream>
#include<vector>
#include<deque>
#include<cmath>
#include<set>
#include<tuple>
#include<limits>
using namespace std;

struct Vec {
    double x, y;
    Vec operator-(Vec r) {
        return {x - r.x, y - r.y};
    }
    double len() {
        return hypot(x, y);
    }
};


int main() {
    int n, m;
    vector<Vec> pts;
    static int travellers[50][50];
    
    cin >> n >> m;
    pts.resize(n);
    for(int i=0;i<n;i++) {
        cin >> pts[i].x >> pts[i].y;
    }
    for(int i=0;i<n;i++) {
        for(int j=0;j<n;j++) {
            cin >> travellers[i][j];
        }
    }
    
    //Now start constructing the network
    set<int> covered = {0};
    int lines_used = 0;
    deque<int> lines[10];
    
    while(covered.size() < (size_t)n) {
        //length, line, a, b
        tuple<double, int, int, int> best = make_tuple(numeric_limits<double>::infinity(), 0, 0, 0);
        
        for(int line=0;line<lines_used;line++) {
            for(int i=0;i<n;i++) if(!covered.count(i)) {
                best = min(best, make_tuple((pts[i]-pts[lines[line].front()]).len(),
                                            line, lines[line].front(), i));
                best = min(best,
                           make_tuple((pts[i]-pts[lines[line].back()]).len(),
                                      line, lines[line].back(), i));
            }
        }
        if(lines_used < m) {
            for(int i : covered) {
                for(int j=0;j<n;j++) if(!covered.count(j)) {
                    best = min(best, make_tuple((pts[j]-pts[i]).len(), lines_used, i, j));
                }
            }
        }
        if(get<1>(best) == lines_used) {
            lines[lines_used].push_back(get<2>(best));
            lines_used++;
        }
        double length;
        int line, a, b;
        tie(length, line, a, b) = best;
        
        if(lines[line].back() == a)
            lines[line].push_back(b);
        else
            lines[line].push_front(b);
        covered.insert(b);
    }
    
    //And output
    for(int i=0;i<lines_used;i++) {
        deque<int> &line = lines[i];
        for(int c : line)
            cout << c+1 << ' ';
        cout << '\n';
    }
    
    return 0;
}