#include <cstdio>
#include <cstdlib>
#include <cstdarg>
#include <cctype>

void done(double n, const char *s, ...) {
	fprintf(stdout, "%lf\n", n);
	va_list ap;
	va_start(ap, s);
	vfprintf(stderr, s, ap);
	va_end(ap);
	fprintf(stderr, "\n");
	exit(0);
}

bool blank(const char *s) {
	while (isspace(*s)) {
		++s;
	}
	return *s == 0;
}

char s[100]; int u;

int n1;
int n2;

int main(int argc, const char *argv[]) {
	if (argc != 4) {
		done(0, "Usage: %s input hint output", argv[0]);
	}

	// don't need the input file

	FILE *hint = fopen(argv[2], "rt");
	if (!hint) {
		done(0, "Can't open hint file %s", argv[2]);
	}
	if (fscanf(hint, "%d", &n1) != 1) {
		done(0, "Error reading hint file");
	}

	FILE *out = fopen(argv[3], "rt");
	if (!out) {
		done(0, "Can't open output file %s", argv[3]);
	}
	if (fgets(s, sizeof(s), out) != s) {
		done(0, "Format error");
	}
	if (sscanf(s, "%d%n", &n2, &u) != 1 || !blank(s + u)) {
		done(0, "Format error");
	}
	if (n2 < 0) {
		done(0, "Wrong answer");
	}
	if (fscanf(out, "%10s", s) > 0) {
		done(0, "Format error");
	}

	if (n1 == n2) {
		done(1, "OK");
	}
	if ((n1 == 0) == (n2 == 0)) {
		done(0.2, "Partial score");
	}
	done(0, "Wrong answer");
}
